<template>
  <div>
    <vc-donut
      background="white"
      foreground="grey"
      unit="%"
      :thickness="30"
      :size="80"
      has-legend
      :sections="carreras"
      :total="alumnos.length"
      :start-angle="0"
      @section-click="handleSectionClick">
      {{alumnos.length}} solicitudes aceptadas
    </vc-donut>

    <v-snackbar
      v-model="snackbar"
      :timeout="timeout"
    >
      {{ text }}
      <v-btn
        color="blue"
        text
        @click="snackbar = false"
      >
        Close
      </v-btn>
    </v-snackbar>
    <br>
    <h3>OTRAS ESTADÍSTICAS</h3>
    <br>

    <vc-donut
      background="white"
      foreground="grey"
      unit="%"
      :thickness="35"
      :size="50"
      :sections="solicitudes"
      has-legend
      legend-placement="right"
      :total="alumnosP.length + alumnos.length"
      :start-angle="0"
      @section-click="handleSectionClick">
      {{alumnosP.length + alumnos.length}} solicitudes totales
    </vc-donut>
    <br>
    <vc-donut
      background="white"
      foreground="grey"
      unit="%"
      :thickness="35"
      :size="50"
      has-legend
      :sections="carrerasP"
      :total="alumnosP.length"
      :start-angle="0"
      @section-click="handleSectionClick">
      {{alumnosP.length}} solicitudes pendientes
    </vc-donut>
    <br><br><br>
  </div>
</template>

<script>
  export default {
    data() {
      return {
        alumnos: [],
        carreras: [],
        alumnosP: [],
        carrerasP: [],
        snackbar: false,
        text: '',
        timeout: 3000,
      };
    },
    computed:{
      solicitudes: function(){
        return [{label: this.alumnosP.length + ' pendientes', value: this.alumnosP.length}, {label: this.alumnos.length + ' aceptadas', value: this.alumnos.length}]
      }
    },
    methods: {
      handleSectionClick(section, event) {
        this.snackbar = true;
        this.text = section.label;
        console.log(`${section.label} clicked.`);
      },
      getCareers(data){
        data.forEach((value, index) => {
          var flag = false;
          var temp = 0;
          for (var i = 0; i < this.carreras.length; i++){
            if (value['carreer'] == this.carreras[i]['label']){
              flag = true;
              temp = i;
            }
          }
          if (flag){
            this.carreras[temp]['value'] = this.carreras[temp]['value'] + 1;
          }else{
            var obj = {label:'', value: 1};
            obj.label = value['carreer'];
            this.carreras.push(obj);
          }
        });
      },
      getCareersP(data){
        data.forEach((value, index) => {
          var flag = false;
          var temp = 0;
          for (var i = 0; i < this.carrerasP.length; i++){
            if (value['carreer'] == this.carrerasP[i]['label']){
              flag = true;
              temp = i;
            }
          }
          if (flag){
            this.carrerasP[temp]['value'] = this.carrerasP[temp]['value'] + 1;
          }else{
            var obj = {label:'', value: 1};
            obj.label = value['carreer'];
            this.carrerasP.push(obj);
          }
        });
      },
      setLabels(){
        this.carreras.forEach((value, index) => {
          this.carreras[index]['label'] = this.carreras[index]['value'] + " - " + this.carreras[index]['label']
        });
        this.carrerasP.forEach((value, index) => {
          this.carrerasP[index]['label'] = this.carrerasP[index]['value'] + " - " + this.carrerasP[index]['label']
        });
      }
    },
    created() {
      var temp = this.$store.getters.getList
      for (var i = 0; i < temp.length; i++){
        if (temp[i]['status'] == '1'){
          this.alumnos.push(temp[i]);
        }else{
          this.alumnosP.push(temp[i]);
        }
      }
      this.getCareers(this.alumnos);
      this.getCareersP(this.alumnosP);
      this.setLabels();
    }
  };
</script>
